REBOL []
; simple meta/escaping handling library
; earl - 2001-11-27

meta-esc: to-char 1

plain-to-meta: func [ data /local char ] [
	forever [
		char: none
		parse data [ thru "\" copy char skip ]
		if none? char [ break ]
		replace/all data rejoin [ "\" char ] rejoin [ meta-esc (to-integer to-char char) ";" ]
		]
	data
	]

meta-to-plain: func [ data /local esc ] [
	forever [
		esc: none
		parse data [ thru meta-esc copy esc to ";" skip ]
		if none? esc [ break ]
		replace/all data rejoin [ meta-esc esc ";" ] rejoin [ "\" (to-char to-integer esc) ]
		]
	data
	]

meta-to-html: func [ data /local esc ] [
	forever [
		esc: none	
		parse data [ thru meta-esc copy esc to ";" skip ]
		if none? esc [ break ]
		replace/all data rejoin [ meta-esc esc ";" ] rejoin [ "&#" (to-integer esc) ";" ]
		]
	data
	]

; performance
plain-to-html: func [ data /local char ] [
	forever [
		char: none
		parse data [ thru "\" copy char skip ]
		if none? char [ break ]
		replace/all data rejoin [ "\" char ] rejoin [ "&#" (to-integer to-char char) ";" ]
		]
	data
	]

comment {
	; test cases
	[ plain-to-meta "asdf" ]
	[ meta-to-plain "asdf" ]
	[ plain-to-meta "as\df" ]
	[ plain-to-meta "as\\df" ]
	[ meta-to-plain plain-to-meta "as\df" ]
	[ meta-to-plain plain-to-meta "as\\df" ]
	[ meta-to-html plain-to-meta "as\df" ]
	[ meta-to-html plain-to-meta "as\\df" ]
	[ plain-to-html "as\df" ]
	[ plain-to-html "as\\df" ]
}
